function run

  more off;
  run_test (@test_1);
  run_test (@test_2);
  run_test (@test_3);
  run_test (@test_4);
  run_test (@test_5);
  run_test (@test_6);
  run_test (@test_7);

end
  
function run_test (fn)
	try
		fprintf ('-- running '); disp (fn);
		fn()
	catch
		fprintf ('-- error occured while executing '); disp (fn);
		disp (lasterr);
	end
end

function s = print_name_list (ml)
	s = '';
	for k = 1:length (ml)
		if length (s) == 0
			s = ml{k}.Name;
		else
			s = [s, ', ', ml{k}.Name];
		end
	end
end

function print_class_properties (cls, nm)
	if nargin < 2
		nm = cls.Name;
	end
	fprintf ('Properties of %s: %s\n', nm, print_name_list (cls.PropertyList));
end

function print_class_methods (cls, nm)
	if nargin < 2
		nm = cls.Name;
	end
	fprintf ('Methods of %s: %s\n', nm, print_name_list (cls.MethodList));
end

function print_object_properties (obj, nm)
	print_class_properties (metaclass (obj), nm);
end

function print_object_methods (obj, nm)
	print_class_methods (metaclass (obj), nm);
end

function question (s)
	input (['=> ', s, ' [press <Enter> when done] ']);
end

function test_1
	x = Test1 ()
	print_object_properties (x, 'x');
	question ('edit Test1.m and uncomment property "p2"');
	y = Test1 ()
	print_object_properties (y, 'y');
end

function test_2
	cb1 = ?Test2_b
	print_class_methods (cb1);
	question ('edit Test2_a.m and make method block sealed');
	cb2 = ?Test2_b
	print_class_methods (cb2);
	x = Test2_b ()
	fprintf ('x.m1() = ');
	disp (x.m1 ());
end

function test_3
	x = ?Test3
	fprintf ('x.m1 () = '); disp (x.m1 ());
	question ('edit @Test3/m1.m and change output value to be 0');
	fprintf ('x.m1 () = '); disp (x.m1 ());
	y = ?Test3
	fprintf ('y.m1 () = '); disp (y.m1 ());
end

function test_4
	addpath ('test4');
	x = Test4 ()
	print_object_properties (x, 'x');
	print_object_methods (x, 'x');
	fprintf ('x.m1 () = '); disp (x.m1 ());
	rmpath ('test4');
	print_object_properties (x, 'x');
	print_object_methods (x, 'x');
	fprintf ('x.m1 () = '); disp (x.m1 ());
	y = Test4 ()
end

function test_5
	addpath ('test5/base');
	addpath ('test5');
	x = Test5_b ()
	print_object_properties (x, 'x');
	print_object_methods (x, 'x');
	fprintf ('x.m1 () = '); disp (x.m1 ());
	rmpath ('test5/base');
	print_object_properties (x, 'x');
	print_object_methods (x, 'x');
	fprintf ('x.m1 () = '); disp (x.m1 ());
	y = Test5_b ()
end

function test_6
	addpath ('test6/d1');
	x = Test6 ()
	print_object_properties (x, 'x');
	print_object_methods (x, 'x');
	fprintf ('x.m1 () = '); disp (x.m1 ());
	rmpath ('test6/d1');
	addpath ('test6/d2');
	print_object_properties (x, 'x');
	print_object_methods (x, 'x');
	fprintf ('x.m1 () = '); disp (x.m1 ());
	y = Test6 ()
	print_object_properties (y, 'y');
	print_object_methods (y, 'y');
	fprintf ('y.m1 () = '); disp (y.m1 ());
end

function test_7
	addpath ('test7/base_a');
	addpath ('test7');
	x = Test7_b ()
	print_object_properties (x, 'x');
	print_object_methods (x, 'x');
	fprintf ('x.m1 () = '); disp (x.m1 ());
	rmpath ('test7/base_a');
	addpath ('test7/base_b');
	print_object_properties (x, 'x');
	print_object_methods (x, 'x');
	fprintf ('x.m1 () = '); disp (x.m1 ());
	y = Test7_b ();
	print_object_properties (y, 'y');
	print_object_methods (y, 'y');
	fprintf ('y.m1 () = '); disp (y.m1 ());
end
